; "fake" 112x200 pixels bitmap for 50hz Sharp MZ-700 by MooZ 
; pubic domain - no warranty implied; use at your own risk
org #1200

SCREEN_WIDTH = 40
SCREEN_HEIGHT = 25

hblnk = 0xe008
vblnk = 0xe002

main:
    di
    im 1

    ld hl, bitmap_att
    ld (display_bitmap.attribute), hl
    ld hl, bitmap_txt
    ld (display_bitmap.text), hl
    call display_bitmap

bitmap_txt: incbin "112_txt.bin"
bitmap_att: incbin "112_att.bin"

macro raster_update
                        ; size:
    ld sp, 0x0000       ; 3
    pop bc              ; 1
    pop de              ; 1
    pop hl              ; 1
    exx                 ; 1
    pop bc              ; 1
    pop de              ; 1
    pop hl              ; 1
    pop af              ; 1

    ld sp, 0x0000       ; 3
    push af             ; 1
    push hl             ; 1
    push de             ; 1
    push bc             ; 1
    exx                 ; 1
    push hl             ; 1
    push de             ; 1
    push bc             ; 1
mend

txt_width = 14
txt_height = 200

att_width = 14
att_height = 25

display_bitmap_end:
    jp    display_bitmap.loop
    ret

display_bitmap:
    ; generate display code
    ld hl, 0xd000+40
    ld (.loop+12), hl
.text equ $+1
    ld hl, 0x0000
    ld (.loop+1), hl

    ld ix, (.text)
    ld iy, 0xd000+40
    
    ld de, .line00
    ld h, 25
.l1:
    ld l, 8
.l0:
    push hl

    ld hl, .loop
    ld bc, 22
    ldir

    ld hl, de
    ld bc, 10
    and a
    sbc hl, bc
    ld a, iyl
    ld (hl), a
    inc hl
    ld a, iyh
    ld (hl), a

    ld hl, de
    ld bc, 21
    and a
    sbc hl, bc
    ld a, ixl
    ld (hl), a
    inc hl
    ld a, ixh
    ld (hl), a

    ld bc, 14
    add ix, bc

    pop hl

    dec l
    jp nz, .l0

    ld bc, 40
    add iy, bc

    dec h
    jp nz, .l1

    ld hl, display_bitmap_end
    ld bc, 4
    ldir

    ; draw attributes
    ld hl, 0xd800+40
    ld (.draw_attributes+12), hl
.attribute equ $+1
    ld hl, 0x0000
    ld (.draw_attributes+1), hl

    ld ixl, att_height
.draw_attributes:
    raster_update

    ld bc, 14
    ld hl, (.draw_attributes+1)
    add hl, bc
    ld (.draw_attributes+1), hl
   
    ld bc, 40
    ld hl, (.draw_attributes+12)
    add hl, bc
    ld (.draw_attributes+12), hl
    
	dec ixl
	jp nz, .draw_attributes

    ; this is the display loop
.run:
    ld hl, vblnk            ; wait for vblank
    ld a, 0x7f
.wait_0:
    cp (hl)
    jp nc, .wait_0
.wait_1:
    cp (hl)
    jp c, .wait_1

.loop:
    raster_update
    
    ld hl, vblnk
    ld a, 0x7f
.wait:
    cp (hl)
    jp nc, .wait

    jp .line00+22
    
.line00:
    ; generated code will go here
